<template>
    <div class="edit-popup">

        <popup ref="popupRef" :title="popupTitle" :async="true" width="80%" @confirm="handleSubmit" @close="handleClose">


            <el-form ref="formRef" :model="formData" label-width="auto" :rules="formRules">
                <el-row :gutter="10">
                    <el-col :span="8">
                        <el-form-item label="父级分类" prop="pid">
                            <!-- <el-select class="w-[280px]" v-model="formData.pid" clearable placeholder="请选择父级分类">
                                <el-option label="全部" :value="0"></el-option>

                                <el-option v-for="(item, index) in imaterialList" :key="index" :label="item.name" :value="item.id" />
                            </el-select> -->
                            <el-cascader :props="props" clearable v-model="formData.pid" :show-all-levels="false"
                                placeholder="为空默认为顶级分类" />
                        </el-form-item>
                    </el-col>


                    <el-col :span="8">
                        <el-form-item label="分类名称" prop="name"
                            :rules="[{ required: true, message: '不可为空', trigger: 'blur' }]">
                            <el-input v-model="formData.name" clearable placeholder="分类名称" />
                        </el-form-item>
                    </el-col>




                </el-row>


            </el-form>
        </popup>

    </div>
</template>

<script lang="ts" setup name="projectEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apimaterialLists, apimaterialAdd, apimaterialEdit, apimaterialDetail, apimaterialDatas } from '@/api/material_classify'
import { timeFormat } from '@/utils/util'
import { isEmail, isIdCard, isPhone } from '@/utils/validate'
import type { PropType } from 'vue'
import configs from "@/config"
import useUserStore from "@/stores/modules/user";
const base_url = configs.baseUrl + configs.urlPrefix
const userStore = useUserStore();
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑材料分类表' : '新增材料分类表'
})

// 表单数据
const formData = reactive({
    id: '',
    pid: '',
    name: ''
})

//层级

const props = {

    lazy: true,
    checkStrictly: true,
    async lazyLoad(node: any, resolve: any) {
        if (node.level == 0) {
            apimaterialLists({ page_no: 1, page_size: 9999 }).then((res) => {

                // res.lists.unshift({
                //     "id": -1,
                //     "pid": 0,
                //     "name": "顶级分类"
                // })

                let nodes = res.lists.map((item: any) => ({
                    value: item.id,
                    label: item.name
                }))
                formData.pid[0] == 0 ? nodes = [{ value: 0, label: "顶级分类" }] : ""
                resolve(nodes)
            })
        }

        else {
            apimaterialDatas({ 'pid': node.value })
                .then((res) => {

                    // 节点数组
                    let nodes = res.map((item: any) => ({
                        value: item.id,
                        label: item.name,
                    }));
                    // resolve 节点返回
                    resolve(nodes);
                    console.log(nodes, "nodes")

                })
                .catch((error) => {
                    console.log(error);
                });
        }
    }


}

// 表单验证
const formRules = reactive<any>({

})



// 获取详情
const setFormData = async (data: Record<any, any>) => {

    // data.all_pid = data.all_pid.pop()

    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    if (data.all_pid && data.all_pid.length > 0) {
        const data1 = data.all_pid.reverse()
        data1.push(data.id)
        formData.pid = data1
    } else {
        const data1 = data.all_pid
        data1.push(data.id)
        formData.pid = data1
    }
    formData.pid.pop()
    if (!formData.pid.length) {
        formData.pid = [0]
    }


}
const getDetail = async (row: Record<string, any>) => {
    const data = await apimaterialDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    if (formData.pid.length > 0) {
        formData.pid = formData.pid[formData.pid.length - 1]
    }
    await formRef.value?.validate()

    if (!formData.pid) formData.pid = 0
    console.log(formData, "form")
    const data = { ...formData }
    mode.value == 'edit'
        ? await apimaterialEdit(data)
        : await apimaterialAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()


}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
